/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.91 Revision 1.143
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2014 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.91 2011/05/01 13:52:09 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.143 2014/11/13 04:19:51 kensington Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed 13# NOTE: KDE 4 ebuilds currently support EAPIs 4 and 5. This will be
14# over time as new EAPI versions are approved. 14# reviewed over time as new EAPI versions are approved.
15
16if [[ -z ${_KDE4_BASE_ECLASS} ]]; then
17_KDE4_BASE_ECLASS=1
18
19# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
20# @DESCRIPTION:
21# If set to "none", do nothing.
22# For any other value, add selinux to IUSE, and depending on that useflag
23# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
24: ${KDE_SELINUX_MODULE:=none}
25
26# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
27# @DESCRIPTION:
28# If defined, launch and use a private dbus session during src_test.
15 29
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED 30# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION: 31# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage. 32# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx 33# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test. 34# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual} 35: ${VIRTUALX_REQUIRED:=manual}
22 36
23inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils 37inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils virtualx versionator eutils multilib
24 38
25if [[ ${BUILD_TYPE} = live ]]; then 39if [[ ${KDE_BUILD_TYPE} = live ]]; then
26 case ${KDE_SCM} in 40 case ${KDE_SCM} in
27 svn) inherit subversion ;; 41 svn) inherit subversion ;;
28 git) inherit git-2 ;; 42 git) inherit git-r3 ;;
29 esac 43 esac
30fi 44fi
31 45
32# @ECLASS-VARIABLE: CMAKE_REQUIRED 46# @ECLASS-VARIABLE: CMAKE_REQUIRED
33# @DESCRIPTION: 47# @DESCRIPTION:
39if [[ ${CMAKE_REQUIRED} = always ]]; then 53if [[ ${CMAKE_REQUIRED} = always ]]; then
40 buildsystem_eclass="cmake-utils" 54 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install" 55 export_fns="src_configure src_compile src_test src_install"
42fi 56fi
43 57
44# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
45if [[ -n ${KDE_MINIMAL} ]]; then
46 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
47 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
48 done
49 unset slot
50 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
51else
52 KDE_MINIMAL_VALID=1
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL 58# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION: 59# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal 60# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4 61# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements. 62# One may override this variable to raise version requirements.
60# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
61# Note that it is fixed to ${SLOT} for kde-base packages. 63# Note that it is fixed to ${PV} for kde-base packages.
62KDE_MINIMAL="${KDE_MINIMAL:-4.4}" 64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
63 65
64# Set slot for KDEBASE known packages 66# Set slot for KDEBASE known packages
65case ${KDEBASE} in 67case ${KDEBASE} in
66 kde-base) 68 kde-base)
67 SLOT=$(_calculate_kde_slot) 69 case ${EAPI} in
68 [[ -z ${SLOT} ]] && die "Unsupported ${PV}" 70 5)
71 SLOT=4/$(get_version_component_range 1-2)
72 ;;
73 *)
74 SLOT=4
75 ;;
76 esac
69 KDE_MINIMAL="${SLOT}" 77 KDE_MINIMAL="${PV}"
70 ;;
71 koffice)
72 SLOT="2"
73 ;; 78 ;;
74 kdevelop) 79 kdevelop)
75 if [[ ${BUILD_TYPE} = live ]]; then 80 if [[ ${KDE_BUILD_TYPE} = live ]]; then
76 # @ECLASS-VARIABLE: KDEVELOP_VERSION 81 # @ECLASS-VARIABLE: KDEVELOP_VERSION
77 # @DESCRIPTION: 82 # @DESCRIPTION:
78 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages. 83 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
79 # Applies to KDEBASE=kdevelop only. 84 # Applies to KDEBASE=kdevelop only.
80 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}" 85 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.9999}"
81 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION 86 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
82 # @DESCRIPTION: 87 # @DESCRIPTION:
83 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages. 88 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
84 # Applies to KDEBASE=kdevelop only. 89 # Applies to KDEBASE=kdevelop only.
85 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}" 90 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-4.9999}"
86 else 91 else
87 case ${PN} in 92 case ${PN} in
88 kdevelop|quanta) 93 kdevelop)
89 KDEVELOP_VERSION=${PV} 94 KDEVELOP_VERSION=${PV}
90 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)" 95 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
91 ;; 96 ;;
92 kdevplatform) 97 kdevplatform|kdevelop-php*|kdevelop-python)
93 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)" 98 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
94 KDEVPLATFORM_VERSION=${PV} 99 KDEVPLATFORM_VERSION=${PV}
95 ;; 100 ;;
96 *) 101 *)
97 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}" 102 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
109unset buildsystem_eclass 114unset buildsystem_eclass
110unset export_fns 115unset export_fns
111 116
112# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED 117# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
113# @DESCRIPTION: 118# @DESCRIPTION:
114# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'. 119# Is qtdeclarative required? Possible values are 'always', 'optional' and 'never'.
115# This variable must be set before inheriting any eclasses. Defaults to 'never'. 120# This variable must be set before inheriting any eclasses. Defaults to 'never'.
116DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}" 121DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
117 122
118# @ECLASS-VARIABLE: QTHELP_REQUIRED 123# @ECLASS-VARIABLE: QTHELP_REQUIRED
119# @DESCRIPTION: 124# @DESCRIPTION:
120# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'. 125# Is qthelp required? Possible values are 'always', 'optional' and 'never'.
121# This variable must be set before inheriting any eclasses. Defaults to 'never'. 126# This variable must be set before inheriting any eclasses. Defaults to 'never'.
122QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}" 127QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
123 128
124# @ECLASS-VARIABLE: OPENGL_REQUIRED 129# @ECLASS-VARIABLE: OPENGL_REQUIRED
125# @DESCRIPTION: 130# @DESCRIPTION:
126# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 131# Is qtopengl required? Possible values are 'always', 'optional' and 'never'.
127# This variable must be set before inheriting any eclasses. Defaults to 'never'. 132# This variable must be set before inheriting any eclasses. Defaults to 'never'.
128OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 133OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
129 134
130# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED 135# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
131# @DESCRIPTION: 136# @DESCRIPTION:
132# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'. 137# Is qtmultimedia required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'never'. 138# This variable must be set before inheriting any eclasses. Defaults to 'never'.
134MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}" 139MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
135
136# @ECLASS-VARIABLE: WEBKIT_REQUIRED
137# @DESCRIPTION:
138# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
139# This variable must be set before inheriting any eclasses. Defaults to 'never'.
140WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
141 140
142# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 141# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
143# @DESCRIPTION: 142# @DESCRIPTION:
144# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 143# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
145# This variable must be set before inheriting any eclasses. Defaults to 'never'. 144# This variable must be set before inheriting any eclasses. Defaults to 'never'.
165# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE 164# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
166# @DESCRIPTION: 165# @DESCRIPTION:
167# Set this varible if you want your live package to manage its 166# Set this varible if you want your live package to manage its
168# translations. (Mostly all kde ebuilds does not ship documentation 167# translations. (Mostly all kde ebuilds does not ship documentation
169# and translations in live ebuilds) 168# and translations in live ebuilds)
170if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then 169if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
171 # Kdebase actualy provides the handbooks even for live stuff 170 # Kdebase actualy provides the handbooks even for live stuff
172 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never 171 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
173 KDE_LINGUAS="" 172 KDE_LINGUAS=""
174fi 173fi
175 174
176# Setup packages inheriting this eclass 175# Setup packages inheriting this eclass
177case ${KDEBASE} in 176case ${KDEBASE} in
178 kde-base) 177 kde-base)
179 HOMEPAGE="http://www.kde.org/" 178 HOMEPAGE="http://www.kde.org/"
180 LICENSE="GPL-2" 179 LICENSE="GPL-2"
181 if [[ $BUILD_TYPE = live ]]; then 180 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
182 # Disable tests for live ebuilds 181 # Disable tests for live ebuilds by default
183 RESTRICT+=" test" 182 RESTRICT+=" test"
184 # Live ebuilds in kde-base default to kdeprefix by default
185 IUSE+=" +kdeprefix"
186 else
187 # All other ebuild types default to -kdeprefix as before
188 IUSE+=" kdeprefix"
189 fi 183 fi
184
190 # This code is to prevent portage from searching GENTOO_MIRRORS for 185 # This code is to prevent portage from searching GENTOO_MIRRORS for
191 # packages that will never be mirrored. (As they only will ever be in 186 # packages that will never be mirrored. (As they only will ever be in
192 # the overlay). 187 # the overlay).
193 case ${PV} in 188 case ${PV} in
194 *9999* | 4.?.[6-9]?) 189 *9999* | 4.?.[6-9]? | 4.??.[6-9]?)
195 RESTRICT+=" mirror" 190 RESTRICT+=" mirror"
196 ;; 191 ;;
197 esac 192 esac
198 # Block installation of other SLOTS unless kdeprefix
199 RDEPEND+=" $(block_other_slots)"
200 ;;
201 koffice)
202 HOMEPAGE="http://www.koffice.org/"
203 LICENSE="GPL-2"
204 ;; 193 ;;
205 kdevelop) 194 kdevelop)
206 HOMEPAGE="http://www.kdevelop.org/" 195 HOMEPAGE="http://www.kdevelop.org/"
207 LICENSE="GPL-2" 196 LICENSE="GPL-2"
208 ;; 197 ;;
209esac 198esac
210 199
211# @ECLASS-VARIABLE: QT_MINIMAL 200# @ECLASS-VARIABLE: QT_MINIMAL
212# @DESCRIPTION: 201# @DESCRIPTION:
213# Determine version of qt we enforce as minimal for the package. 202# Determine version of qt we enforce as minimal for the package.
214if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then
215 QT_MINIMAL="${QT_MINIMAL:-4.7.0}" 203QT_MINIMAL="${QT_MINIMAL:-4.8.5}"
216else
217 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
218fi
219 204
220# Declarative dependencies 205# Declarative dependencies
221qtdeclarativedepend=" 206qtdeclarativedepend="
222 >=x11-libs/qt-declarative-${QT_MINIMAL}:4 207 >=dev-qt/qtdeclarative-${QT_MINIMAL}:4
223" 208"
224case ${DECLARATIVE_REQUIRED} in 209case ${DECLARATIVE_REQUIRED} in
225 always) 210 always)
226 COMMONDEPEND+=" ${qtdeclarativedepend}" 211 COMMONDEPEND+=" ${qtdeclarativedepend}"
227 ;; 212 ;;
233esac 218esac
234unset qtdeclarativedepend 219unset qtdeclarativedepend
235 220
236# QtHelp dependencies 221# QtHelp dependencies
237qthelpdepend=" 222qthelpdepend="
238 >=x11-libs/qt-assistant-${QT_MINIMAL}:4 223 >=dev-qt/qthelp-${QT_MINIMAL}:4
239" 224"
240case ${QTHELP_REQUIRED} in 225case ${QTHELP_REQUIRED} in
241 always) 226 always)
242 COMMONDEPEND+=" ${qthelpdepend}" 227 COMMONDEPEND+=" ${qthelpdepend}"
243 ;; 228 ;;
248esac 233esac
249unset qthelpdepend 234unset qthelpdepend
250 235
251# OpenGL dependencies 236# OpenGL dependencies
252qtopengldepend=" 237qtopengldepend="
253 >=x11-libs/qt-opengl-${QT_MINIMAL}:4 238 >=dev-qt/qtopengl-${QT_MINIMAL}:4
254" 239"
255case ${OPENGL_REQUIRED} in 240case ${OPENGL_REQUIRED} in
256 always) 241 always)
257 COMMONDEPEND+=" ${qtopengldepend}" 242 COMMONDEPEND+=" ${qtopengldepend}"
258 ;; 243 ;;
264esac 249esac
265unset qtopengldepend 250unset qtopengldepend
266 251
267# MultiMedia dependencies 252# MultiMedia dependencies
268qtmultimediadepend=" 253qtmultimediadepend="
269 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4 254 >=dev-qt/qtmultimedia-${QT_MINIMAL}:4
270" 255"
271case ${MULTIMEDIA_REQUIRED} in 256case ${MULTIMEDIA_REQUIRED} in
272 always) 257 always)
273 COMMONDEPEND+=" ${qtmultimediadepend}" 258 COMMONDEPEND+=" ${qtmultimediadepend}"
274 ;; 259 ;;
277 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )" 262 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
278 ;; 263 ;;
279 *) ;; 264 *) ;;
280esac 265esac
281unset qtmultimediadepend 266unset qtmultimediadepend
282
283# WebKit dependencies
284case ${KDE_REQUIRED} in
285 always)
286 qtwebkitusedeps="[kde]"
287 ;;
288 optional)
289 qtwebkitusedeps="[kde?]"
290 ;;
291 *) ;;
292esac
293qtwebkitdepend="
294 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
295"
296unset qtwebkitusedeps
297case ${WEBKIT_REQUIRED} in
298 always)
299 COMMONDEPEND+=" ${qtwebkitdepend}"
300 ;;
301 optional)
302 IUSE+=" webkit"
303 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
304 ;;
305 *) ;;
306esac
307unset qtwebkitdepend
308 267
309# CppUnit dependencies 268# CppUnit dependencies
310cppuintdepend=" 269cppuintdepend="
311 dev-util/cppunit 270 dev-util/cppunit
312" 271"
324 283
325# KDE dependencies 284# KDE dependencies
326# Qt accessibility classes are needed in various places, bug 325461 285# Qt accessibility classes are needed in various places, bug 325461
327kdecommondepend=" 286kdecommondepend="
328 dev-lang/perl 287 dev-lang/perl
288 >=dev-qt/qt3support-${QT_MINIMAL}:4[accessibility]
329 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 289 >=dev-qt/qtcore-${QT_MINIMAL}:4[qt3support,ssl]
290 >=dev-qt/qtdbus-${QT_MINIMAL}:4
291 >=dev-qt/designer-${QT_MINIMAL}:4[-phonon]
330 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 292 >=dev-qt/qtgui-${QT_MINIMAL}:4[accessibility,dbus(+)]
331 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
332 >=x11-libs/qt-script-${QT_MINIMAL}:4 293 >=dev-qt/qtscript-${QT_MINIMAL}:4
333 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 294 >=dev-qt/qtsql-${QT_MINIMAL}:4[qt3support]
334 >=x11-libs/qt-svg-${QT_MINIMAL}:4 295 >=dev-qt/qtsvg-${QT_MINIMAL}:4
335 >=x11-libs/qt-test-${QT_MINIMAL}:4 296 >=dev-qt/qttest-${QT_MINIMAL}:4
336 !aqua? ( 297 >=dev-qt/qtwebkit-${QT_MINIMAL}:4
337 x11-libs/libXext
338 x11-libs/libXt
339 x11-libs/libXxf86vm
340 )
341" 298"
342 299
343if [[ ${PN} != kdelibs ]]; then 300if [[ ${PN} != kdelibs ]]; then
344 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 301 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
345 if [[ ${KDEBASE} = kdevelop ]]; then 302 if [[ ${KDEBASE} = kdevelop ]]; then
350 # Applies to KDEBASE=kdevelop only. 307 # Applies to KDEBASE=kdevelop only.
351 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}" 308 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
352 case ${KDEVPLATFORM_REQUIRED} in 309 case ${KDEVPLATFORM_REQUIRED} in
353 always) 310 always)
354 kdecommondepend+=" 311 kdecommondepend+="
355 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION} 312 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}:4
356 " 313 "
357 ;; 314 ;;
358 *) ;; 315 *) ;;
359 esac 316 esac
360 fi 317 fi
361 fi 318 fi
362fi 319fi
363 320
364kdedepend=" 321kdedepend="
365 dev-util/automoc 322 dev-util/automoc
366 dev-util/pkgconfig 323 virtual/pkgconfig
367 !aqua? ( 324 !aqua? (
368 >=x11-libs/libXtst-1.1.0 325 >=x11-libs/libXtst-1.1.0
369 x11-proto/xf86vidmodeproto 326 x11-proto/xf86vidmodeproto
370 ) 327 )
371" 328"
375# all packages needs oxygen icons for basic iconset 332# all packages needs oxygen icons for basic iconset
376if [[ ${PN} != oxygen-icons ]]; then 333if [[ ${PN} != oxygen-icons ]]; then
377 kderdepend+=" $(add_kdebase_dep oxygen-icons)" 334 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
378fi 335fi
379 336
380# add a dependency over kde-l10n if EAPI4 or better is around 337# add a dependency over kde-l10n
381if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then 338if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} ]]; then
382 for _lingua in ${KDE_LINGUAS}; do 339 for _lingua in ${KDE_LINGUAS}; do
383 # if our package has lignuas, pull in kde-l10n with selected lingua enabled, 340 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
384 # but only for selected ones. 341 # but only for selected ones.
385 # this can't be done on one line because if user doesn't use any localisation 342 # this can't be done on one line because if user doesn't use any localisation
386 # then he is probably not interested in kde-l10n at all. 343 # then he is probably not interested in kde-l10n at all.
410 ;; 367 ;;
411 *) ;; 368 *) ;;
412esac 369esac
413unset kdehandbookdepend kdehandbookrdepend 370unset kdehandbookdepend kdehandbookrdepend
414 371
372case ${KDE_SELINUX_MODULE} in
373 none) ;;
374 *)
375 IUSE+=" selinux"
376 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
377 ;;
378esac
379
380# We always need the aqua useflag because otherwise we cannot = refer to it inside
381# add_kdebase_dep. This was always kind of a bug, but came to light with EAPI=5
382# (where referring to a use flag not in IUSE masks the ebuild).
383# The only alternative would be to prohibit using add_kdebase_dep if KDE_REQUIRED=never
384IUSE+=" aqua"
385
415case ${KDE_REQUIRED} in 386case ${KDE_REQUIRED} in
416 always) 387 always)
417 IUSE+=" aqua"
418 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}" 388 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
419 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}" 389 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
420 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}" 390 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
421 ;; 391 ;;
422 optional) 392 optional)
423 IUSE+=" aqua kde" 393 IUSE+=" kde"
424 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )" 394 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
425 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )" 395 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
426 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )" 396 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
427 ;; 397 ;;
428 *) ;; 398 *) ;;
437# Accumulate dependencies set by this eclass 407# Accumulate dependencies set by this eclass
438DEPEND+=" ${COMMONDEPEND}" 408DEPEND+=" ${COMMONDEPEND}"
439RDEPEND+=" ${COMMONDEPEND}" 409RDEPEND+=" ${COMMONDEPEND}"
440unset COMMONDEPEND 410unset COMMONDEPEND
441 411
442# Add experimental kdeenablefinal, masked by default
443IUSE+=" kdeenablefinal"
444
445# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 412# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
446# koffice ebuild, the URI should be set in the ebuild itself 413# kdevelop ebuild, the URI should be set in the ebuild itself
447_calculate_src_uri() { 414_calculate_src_uri() {
448 debug-print-function ${FUNCNAME} "$@" 415 debug-print-function ${FUNCNAME} "$@"
449 416
450 local _kmname _kmname_pv 417 local _kmname _kmname_pv
451 418
452 # we calculate URI only for known KDEBASE modules 419 # we calculate URI only for known KDEBASE modules
453 [[ -n ${KDEBASE} ]] || return 420 [[ -n ${KDEBASE} ]] || return
454 421
455 # calculate tarball module name 422 # calculate tarball module name
456 if [[ -n ${KMNAME} ]]; then 423 if [[ -n ${KMNAME} ]]; then
457 # fixup kdebase-apps name
458 case ${KMNAME} in
459 kdebase-apps)
460 _kmname="kdebase" ;;
461 *)
462 _kmname="${KMNAME}" ;; 424 _kmname="${KMNAME}"
463 esac
464 else 425 else
465 _kmname=${PN} 426 _kmname=${PN}
466 fi 427 fi
467 _kmname_pv="${_kmname}-${PV}" 428 _kmname_pv="${_kmname}-${PV}"
468 case ${KDEBASE} in 429 case ${KDEBASE} in
469 kde-base) 430 kde-base)
470 case ${PV} in 431 case ${PV} in
471 4.[456].8[05] | 4.[456].9[023568]) 432 4.4.11.1)
433 # KDEPIM 4.4, special case
434 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
435 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
436 4.?.[6-9]? | 4.??.[6-9]?)
472 # Unstable KDE SC releases 437 # Unstable KDE SC releases
438 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
439 4.[1-7].[12345])
440 # Stable KDE SC with old .bz2 support
473 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" 441 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
474 # KDEPIM IS SPECIAL 442 4.11.9)
475 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2" 443 # Part of 4.12 actually, sigh. Not stable for next release!
476 ;;
477 4.4.[6789] | 4.4.1?*)
478 # Stable kdepim releases
479 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" 444 SRC_URI="mirror://kde/stable/4.12.5/src/${_kmname_pv}.tar.xz" ;;
480 ;; 445 4.11.11)
446 # Part of 4.13 actually, sigh. Not stable for next release!
447 SRC_URI="mirror://kde/stable/4.13.3/src/${_kmname_pv}.tar.xz" ;;
448 4.11.12)
449 # Part of 4.14 actually, sigh. Not stable for next release!
450 SRC_URI="mirror://kde/stable/4.14.1/src/${_kmname_pv}.tar.xz" ;;
451 4.11.13)
452 # Part of 4.14 actually, sigh. Not stable for next release!
453 SRC_URI="mirror://kde/stable/4.14.2/src/${_kmname_pv}.tar.xz" ;;
454 4.11.14)
455 # Part of 4.14 actually, sigh. Not stable for next release!
456 SRC_URI="mirror://kde/stable/4.14.3/src/${_kmname_pv}.tar.xz" ;;
481 *) 457 *)
482 # Stable KDE SC releases 458 # Stable KDE SC releases
483 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" 459 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
484 ;;
485 esac 460 esac
486 ;; 461 ;;
487 koffice) 462 kdevelop|kdevelop-php*|kdevplatform)
488 case ${PV} in 463 case ${KDEVELOP_VERSION} in
489 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 464 4.[123].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
490 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 465 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
491 esac 466 esac
492 ;;
493 kdevelop)
494 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
495 ;; 467 ;;
496 esac 468 esac
497} 469}
498 470
499_calculate_live_repo() { 471_calculate_live_repo() {
503 case ${KDE_SCM} in 475 case ${KDE_SCM} in
504 svn) 476 svn)
505 # Determine branch URL based on live type 477 # Determine branch URL based on live type
506 local branch_prefix 478 local branch_prefix
507 case ${PV} in 479 case ${PV} in
508 9999*) 480 4.9999*)
509 # trunk 481 # trunk
510 branch_prefix="trunk/KDE" 482 branch_prefix="trunk/KDE"
511 ;; 483 ;;
512 *) 484 *)
513 # branch 485 # branch
514 branch_prefix="branches/KDE/${SLOT}" 486 branch_prefix="branches/KDE/$(get_kde_version)"
515 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX 487 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
516 # @DESCRIPTION 488 # @DESCRIPTION
517 # Suffix appended to ESVN_PROJECT depending on fetched branch. 489 # Suffix appended to ESVN_PROJECT depending on fetched branch.
518 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise. 490 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
519 ESVN_PROJECT_SUFFIX="-${PV}" 491 ESVN_PROJECT_SUFFIX="-${PV}"
552 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta 524 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
553 # build packages from same svn location. 525 # build packages from same svn location.
554 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 526 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
555 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 527 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
556 ;; 528 ;;
557 koffice)
558 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
559 ;;
560 *) 529 *)
561 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 530 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
562 ;; 531 ;;
563 esac 532 esac
564 else 533 else
567 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 536 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
568 fi 537 fi
569 # @ECLASS-VARIABLE: ESVN_UP_FREQ 538 # @ECLASS-VARIABLE: ESVN_UP_FREQ
570 # @DESCRIPTION: 539 # @DESCRIPTION:
571 # This variable is used for specifying the timeout between svn synces 540 # This variable is used for specifying the timeout between svn synces
572 # for kde-base and koffice modules. Does not affect misc apps. 541 # for kde-base modules. Does not affect misc apps.
573 # Default value is 1 hour. 542 # Default value is 1 hour.
574 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 543 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
575 ;; 544 ;;
576 git) 545 git)
577 local _kmname 546 local _kmname
578 # @ECLASS-VARIABLE: EGIT_MIRROR 547 # @ECLASS-VARIABLE: EGIT_MIRROR
579 # @DESCRIPTION: 548 # @DESCRIPTION:
593 else 562 else
594 _kmname=${PN} 563 _kmname=${PN}
595 fi 564 fi
596 565
597 # default branching 566 # default branching
598 case ${PV} in 567 [[ ${PV} != 4.9999* && ${KDEBASE} == kde-base ]] && \
599 9999*) ;; 568 EGIT_BRANCH="KDE/$(get_kde_version)"
600 *)
601 # set EGIT_BRANCH and EGIT_COMMIT to ${SLOT}
602 case ${_kmname} in
603 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs)
604 EGIT_BRANCH="${SLOT}"
605 ;;
606 *) EGIT_BRANCH="KDE/${SLOT}" ;;
607 esac
608 ;;
609 esac
610 569
570 # default repo uri
611 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}" 571 EGIT_REPO_URI+=( "${EGIT_MIRROR}/${_kmname}" )
612 572
613 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}" 573 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
614 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}" 574 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
615 ;; 575 ;;
616 esac 576 esac
617} 577}
618 578
619case ${BUILD_TYPE} in 579case ${KDE_BUILD_TYPE} in
620 live) _calculate_live_repo ;; 580 live) _calculate_live_repo ;;
621 *) _calculate_src_uri ;; 581 *) _calculate_src_uri ;;
622esac 582esac
623 583
624debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 584debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
625 585
626# @ECLASS-VARIABLE: PREFIX 586# @ECLASS-VARIABLE: PREFIX
627# @DESCRIPTION: 587# @DESCRIPTION:
628# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 588# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
629# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 589# kde-base packages go into KDE4 installation directory (/usr).
630# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 590# No matter the PREFIX, package will be built against KDE installed in /usr.
631 591
632# @FUNCTION: kde4-base_pkg_setup 592# @FUNCTION: kde4-base_pkg_setup
633# @DESCRIPTION: 593# @DESCRIPTION:
634# Do the basic kdeprefix KDEDIR settings and determine with which kde should 594# Do some basic settings
635# optional applications link
636kde4-base_pkg_setup() { 595kde4-base_pkg_setup() {
637 debug-print-function ${FUNCNAME} "$@" 596 debug-print-function ${FUNCNAME} "$@"
638 597
639 # QA ebuilds 598 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
640 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 599 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
600 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
601 fi
641 602
642 # Don't set KDEHOME during compilation, it will cause access violations 603 # Don't set KDEHOME during compilation, it will cause access violations
643 unset KDEHOME 604 unset KDEHOME
644 605
645 # Check if gcc compiler is fresh enough. 606 # Check if gcc compiler is fresh enough.
646 # In theory should be in pkg_pretend but we check it only for kdelibs there 607 # In theory should be in pkg_pretend but we check it only for kdelibs there
647 # and for others we do just quick scan in pkg_setup because pkg_pretend 608 # and for others we do just quick scan in pkg_setup because pkg_pretend
648 # executions consume quite some time. 609 # executions consume quite some time (ie. when merging 300 packages at once will cause 300 checks)
610 if [[ ${MERGE_TYPE} != binary ]]; then
649 [[ $(gcc-major-version) -lt 4 ]] || \ 611 [[ $(gcc-major-version) -lt 4 ]] || \
650 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \ 612 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 6 ]] ) \
651 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)." 613 && die "Sorry, but gcc-4.6 and earlier wont work for some KDE packages."
614 fi
652 615
653 if [[ ${KDEBASE} = kde-base ]]; then
654 if use kdeprefix; then
655 KDEDIR=/usr/kde/${SLOT}
656 else
657 KDEDIR=/usr 616 KDEDIR=/usr
658 fi
659 : ${PREFIX:=${KDEDIR}}
660 else
661 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
662 KDEDIR=
663 local kde_minimal_met
664 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
665 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
666 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
667 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
668 KDEDIR=/usr/kde/${slot}
669 else
670 KDEDIR=/usr
671 fi
672 break;
673 fi
674 done
675 unset slot
676
677 # Bail out if kdelibs required but not found
678 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
679 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
680 else
681 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
682 fi
683
684 : ${PREFIX:=/usr} 617 : ${PREFIX:=/usr}
685 fi 618 EKDEDIR=${EPREFIX}/usr
686 EKDEDIR=${EPREFIX}${KDEDIR}
687 619
688 # Point pkg-config path to KDE *.pc files
689 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
690 # Point to correct QT plugins path 620 # Point to correct QT plugins path
691 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 621 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
692 622
693 # Fix XDG collision with sandbox 623 # Fix XDG collision with sandbox
694 export XDG_CONFIG_HOME="${T}" 624 export XDG_CONFIG_HOME="${T}"
695} 625}
696 626
698# @DESCRIPTION: 628# @DESCRIPTION:
699# This function unpacks the source tarballs for KDE4 applications. 629# This function unpacks the source tarballs for KDE4 applications.
700kde4-base_src_unpack() { 630kde4-base_src_unpack() {
701 debug-print-function ${FUNCNAME} "$@" 631 debug-print-function ${FUNCNAME} "$@"
702 632
703 if [[ ${BUILD_TYPE} = live ]]; then 633 if [[ ${KDE_BUILD_TYPE} = live ]]; then
704 case ${KDE_SCM} in 634 case ${KDE_SCM} in
705 svn) 635 svn)
706 migrate_store_dir
707 subversion_src_unpack 636 subversion_src_unpack
708 ;; 637 ;;
709 git) 638 git)
710 git-2_src_unpack 639 git-r3_src_unpack
711 ;; 640 ;;
712 esac 641 esac
713 else 642 else
714 unpack ${A} 643 unpack ${A}
715 fi 644 fi
732 fi 661 fi
733 662
734 # Enable/disable handbooks for kde4-base packages 663 # Enable/disable handbooks for kde4-base packages
735 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 664 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
736 # kdelibs inherits kde4-base but handle installing the handbook itself 665 # kdelibs inherits kde4-base but handle installing the handbook itself
737 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then 666 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
738 if [[ ${KDEBASE} == kde-base ]]; then 667 if [[ ${KDEBASE} == kde-base ]]; then
739 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then 668 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
740 # documentation in kde4-functions 669 # documentation in kde4-functions
741 : ${KDE_DOC_DIRS:=doc} 670 : ${KDE_DOC_DIRS:=doc}
742 local dir 671 local dir
752 enable_selected_doc_linguas 681 enable_selected_doc_linguas
753 fi 682 fi
754 fi 683 fi
755 684
756 # SCM bootstrap 685 # SCM bootstrap
757 if [[ ${BUILD_TYPE} = live ]]; then 686 if [[ ${KDE_BUILD_TYPE} = live ]]; then
758 case ${KDE_SCM} in 687 case ${KDE_SCM} in
759 svn) subversion_src_prepare ;; 688 svn) subversion_src_prepare ;;
760 esac 689 esac
761 fi 690 fi
762 691
763 # Apply patches 692 # Apply patches, cmake-utils does the job already
764 base_src_prepare 693 cmake-utils_src_prepare
765 694
766 # Save library dependencies 695 # Save library dependencies
767 if [[ -n ${KMSAVELIBS} ]] ; then 696 if [[ -n ${KMSAVELIBS} ]] ; then
768 save_library_dependencies 697 save_library_dependencies
769 fi 698 fi
771 # Inject library dependencies 700 # Inject library dependencies
772 if [[ -n ${KMLOADLIBS} ]] ; then 701 if [[ -n ${KMLOADLIBS} ]] ; then
773 load_library_dependencies 702 load_library_dependencies
774 fi 703 fi
775 704
776 # Replace KDE4Workspace library targets
777 find "${S}" -name CMakeLists.txt \
778 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
779 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
780 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
781 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
782 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
783 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
784 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
785 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
786 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
787 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
788 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
789 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
790 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
791 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
792 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
793 || die 'failed to replace KDE4Workspace library targets'
794
795 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/... 705 # Hack for manuals relying on outdated DTD, only outside kde-base/...
796 if [[ -z ${KDEBASE} ]]; then 706 if [[ -z ${KDEBASE} ]]; then
797 find "${S}" -name "*.docbook" \ 707 find "${S}" -name "*.docbook" \
798 -exec sed -i -r \ 708 -exec sed -i -r \
799 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \ 709 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
800 || die 'failed to fix DocBook variant version' 710 || die 'failed to fix DocBook variant version'
808 debug-print-function ${FUNCNAME} "$@" 718 debug-print-function ${FUNCNAME} "$@"
809 719
810 # Build tests in src_test only, where we override this value 720 # Build tests in src_test only, where we override this value
811 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 721 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
812 722
813 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 723 if use_if_iuse debug; then
814 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
815 fi
816
817 if has debug ${IUSE//+} && use debug; then
818 # Set "real" debug mode 724 # Set "real" debug mode
819 CMAKE_BUILD_TYPE="Debugfull" 725 CMAKE_KDE_BUILD_TYPE="Debugfull"
820 else 726 else
821 # Handle common release builds 727 # Handle common release builds
822 append-cppflags -DQT_NO_DEBUG 728 append-cppflags -DQT_NO_DEBUG
823 fi 729 fi
824 730
829 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 735 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
830 736
831 # Use colors 737 # Use colors
832 QTEST_COLORED=1 738 QTEST_COLORED=1
833 739
834 # Shadow existing /usr installations 740 # Shadow existing installations
835 unset KDEDIRS 741 unset KDEDIRS
836 742
837 # Handle kdeprefix-ed KDE
838 if [[ ${KDEDIR} != /usr ]]; then
839 # Override some environment variables - only when kdeprefix is different,
840 # to not break ccache/distcc
841 PATH="${EKDEDIR}/bin:${PATH}"
842
843 # Append library search path
844 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
845
846 # Append full RPATH
847 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
848
849 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
850 # when more are present
851 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
852 fi
853
854 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling 743 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
855 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4) 744 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
856 #kde-config -path data unavailable when cross-compiling 745 #kde-config -path data unavailable when cross-compiling
857 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/) 746 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
858 747
859 # Handle kdeprefix in application itself
860 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
861 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 748 # sysconf needs to be /etc, not /usr/etc
862 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 749 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
863 fi
864 750
865 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 751 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
752 if [[ ${mycmakeargs} ]]; then
753 eqawarn "mycmakeargs should always be declared as an array, not a string"
754 fi
866 mycmakeargs=(${mycmakeargs}) 755 mycmakeargs=(${mycmakeargs})
867 fi 756 fi
868 757
869 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}") 758 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
870 759
883# @FUNCTION: kde4-base_src_test 772# @FUNCTION: kde4-base_src_test
884# @DESCRIPTION: 773# @DESCRIPTION:
885# Function for testing KDE4 applications. 774# Function for testing KDE4 applications.
886kde4-base_src_test() { 775kde4-base_src_test() {
887 debug-print-function ${FUNCNAME} "$@" 776 debug-print-function ${FUNCNAME} "$@"
777
778 local kded4_pid
779
780 _test_runner() {
781 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
782 export $(dbus-launch)
783 kded4 2>&1 > /dev/null &
784 kded4_pid=$!
785 fi
786
787 cmake-utils_src_test
788 }
789
790 # When run as normal user during ebuild development with the ebuild command, the
791 # kde tests tend to access the session DBUS. This however is not possible in a real
792 # emerge or on the tinderbox.
793 # > make sure it does not happen, so bad tests can be recognized and disabled
794 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
888 795
889 # Override this value, set in kde4-base_src_configure() 796 # Override this value, set in kde4-base_src_configure()
890 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON) 797 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
891 cmake-utils_src_configure 798 cmake-utils_src_configure
892 kde4-base_src_compile 799 kde4-base_src_compile
893
894 # When run as normal user during ebuild development with the ebuild command, the
895 # kde tests tend to access the session DBUS. This however is not possible in a real
896 # emerge or on the tinderbox.
897 # > make sure it does not happen, so bad tests can be recognized and disabled
898 unset DBUS_SESSION_BUS_ADDRESS
899 800
900 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then 801 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
901 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default 802 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
902 if [[ ${VIRTUALX_COMMAND} != emake ]]; then 803 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
903 # surprise- we are already INSIDE virtualmake!!! 804 # surprise- we are already INSIDE virtualmake!!!
904 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality." 805 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
905 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild." 806 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
906 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the" 807 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
907 debug-print " kde4-base.eclass docs for details... Applying workaround." 808 debug-print " kde4-base.eclass docs for details... Applying workaround."
908 cmake-utils_src_test 809 _test_runner
909 else 810 else
910 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake 811 VIRTUALX_COMMAND="_test_runner" virtualmake
911 fi 812 fi
912 else 813 else
913 cmake-utils_src_test 814 _test_runner
815 fi
816
817 if [ -n "${kded4_pid}" ] ; then
818 kill ${kded4_pid}
819 fi
820
821 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
822 kill ${DBUS_SESSION_BUS_PID}
914 fi 823 fi
915} 824}
916 825
917# @FUNCTION: kde4-base_src_install 826# @FUNCTION: kde4-base_src_install
918# @DESCRIPTION: 827# @DESCRIPTION:
935 done 844 done
936 fi 845 fi
937 846
938 cmake-utils_src_install 847 cmake-utils_src_install
939 848
940 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed, 849 # We don't want ${PREFIX}/share/doc/HTML to be compressed,
941 # because then khelpcenter can't find the docs 850 # because then khelpcenter can't find the docs
942 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] && 851 [[ -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
943 docompress -x ${PREFIX}/share/doc/HTML 852 docompress -x ${PREFIX}/share/doc/HTML
944} 853}
945 854
946# @FUNCTION: kde4-base_pkg_preinst 855# @FUNCTION: kde4-base_pkg_preinst
947# @DESCRIPTION: 856# @DESCRIPTION:
948# Function storing icon caches 857# Function storing icon caches
949kde4-base_pkg_preinst() { 858kde4-base_pkg_preinst() {
950 debug-print-function ${FUNCNAME} "$@" 859 debug-print-function ${FUNCNAME} "$@"
951 860
952 gnome2_icon_savelist 861 gnome2_icon_savelist
862 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
863 subversion_pkg_preinst
864 fi
953} 865}
954 866
955# @FUNCTION: kde4-base_pkg_postinst 867# @FUNCTION: kde4-base_pkg_postinst
956# @DESCRIPTION: 868# @DESCRIPTION:
957# Function to rebuild the KDE System Configuration Cache after an application has been installed. 869# Function to rebuild the KDE System Configuration Cache after an application has been installed.
962 fdo-mime_desktop_database_update 874 fdo-mime_desktop_database_update
963 fdo-mime_mime_database_update 875 fdo-mime_mime_database_update
964 buildsycoca 876 buildsycoca
965 877
966 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 878 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
967 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
968 echo
969 ewarn "WARNING! you have kdeenable final useflag enabled."
970 ewarn "This useflag needs to be enabled on ALL kde using packages and"
971 ewarn "is known to cause issues."
972 ewarn "You are using this setup at your own risk and the kde team does not"
973 ewarn "take responsibilities for dead kittens."
974 echo
975 fi
976 if [[ ${BUILD_TYPE} = live ]]; then 879 if [[ ${KDE_BUILD_TYPE} = live ]]; then
977 echo 880 echo
978 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}" 881 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
979 einfo "Use it at your own risk." 882 einfo "Use it at your own risk."
980 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!" 883 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
981 echo
982 elif [[ ${BUILD_TYPE} != live ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
983 # warning about kdeprefix for non-live users
984 echo
985 ewarn "WARNING! You have the kdeprefix useflag enabled."
986 ewarn "This setting is strongly discouraged and might lead to potential trouble"
987 ewarn "with KDE update strategies."
988 ewarn "You are using this setup at your own risk and the kde team does not"
989 ewarn "take responsibilities for dead kittens."
990 echo 884 echo
991 fi 885 fi
992 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta 886 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
993 if [[ ${KDEBASE} != kde-base ]] && \ 887 if [[ ${KDEBASE} != kde-base ]] && \
994 ! has_version 'kde-base/kdebase-runtime-meta' && \ 888 ! has_version 'kde-base/kdebase-runtime-meta' && \
1013 gnome2_icon_cache_update 907 gnome2_icon_cache_update
1014 fdo-mime_desktop_database_update 908 fdo-mime_desktop_database_update
1015 fdo-mime_mime_database_update 909 fdo-mime_mime_database_update
1016 buildsycoca 910 buildsycoca
1017} 911}
912
913fi

Legend:
Removed from v.1.91  
changed lines
  Added in v.1.143

  ViewVC Help
Powered by ViewVC 1.1.20